/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import java.io.*;

public class HelpDialog extends Dialog
{
    String BROWSER="";
    String INFO_PATH="";
	public HelpDialog(Frame parent)
	{
		super(parent);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(522,343);
		setVisible(false);
		CancelButton.setLabel("Cancel");
		add(CancelButton);
		CancelButton.setBackground(java.awt.Color.lightGray);
		CancelButton.setBounds(348,288,132,30);
		Showbutton.setLabel("Show Help");
		add(Showbutton);
		Showbutton.setBackground(java.awt.Color.lightGray);
		Showbutton.setBounds(48,288,132,30);
		FileList.setBackground(java.awt.Color.white);
		FileList.setFont(new Font("Courier", Font.PLAIN, 12));
		add(FileList);
		FileList.setBounds(24,24,480,240);
		setTitle("Selection of Help Files");
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		Showbutton.addActionListener(lSymAction);
		CancelButton.addActionListener(lSymAction);
		//}}
	}
	
	public HelpDialog(Frame parent, boolean modal, String browser, String infopath)
	{
		this(parent);
        setModal(modal);
        BROWSER = browser;
        INFO_PATH = infopath;
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button CancelButton = new java.awt.Button();
	java.awt.Button Showbutton = new java.awt.Button();
	java.awt.List FileList = new java.awt.List(0);
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == HelpDialog.this)
				HelpDialog_WindowClosing(event);
		}
	}
	
	void HelpDialog_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == Showbutton)
				Showbutton_ActionPerformed(event);
			else if (object == CancelButton)
				CancelButton_ActionPerformed(event);
		}
	}

	void Showbutton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Show a PDF document
		StringFormat Format = new StringFormat();
		String filename =Format.getItemfrom(FileList.getSelectedItem(), 2, ':'); 
		System.out.println(BROWSER+" "+INFO_PATH+filename);
		try {
	     Process myProcess = Runtime.getRuntime().exec(BROWSER+" "+INFO_PATH+filename);
	     DataInputStream in = new DataInputStream(myProcess.getInputStream());
          
	    }    
	    catch (Exception Ex)
        {
           System.out.println(Ex.getMessage());
           Ex.printStackTrace() ;

        }
	 
		setVisible(false);	 
	}

	void CancelButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// Cancel
		setVisible(false);
	}
}
